require 'yaml'
require 'tsort'

class Hash
  include TSort
  alias tsort_each_node each_key
  def tsort_each_child(node, &block)
    fetch(node).each(&block)
  end
end

module Momonga
  class ClassPath
    def initialize(name, depends, classpath)
      @name = name
      @depends = depends
      @classpath = classpath
    end
    attr_reader :name, :classpath
    def depends
      @depends = [] if @depends.nil?
      @depends
    end
    def depends=(depends)
      @depends = depends
    end
  end

  class AlternativeSlave
    def initialize(name, link, path)
      @name = name
      @link = link
      @path = path
    end
    attr_reader :name, :link, :path
  end

  class Alternative
    def initialize(name, link, path, priority, slaves=nil)
      @name = name
      @link = link
      @path = path
      @priority = priority
      @slaves = slaves.nil? ? [] : slaves.collect {|slave| AlternativeSlave.new(*slave) }
    end
    attr_reader :name, :link, :path, :priority, :slaves
  end
end
